function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
var _excluded = ["method", "head", "data"];
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import axios from 'axios';

// axios 默认配置
// axios.defaults.timeout = 5000
axios.defaults.headers.post['Content-Type'] = 'application/json;charset=UTF-8';

// response中提取result
function getResult(response) {
  var result = response;
  // axios多返回了一层, 则获取接口返回的data
  if (response.config && response.data) {
    result = response.data;
  }
  if (typeof result === 'string') {
    try {
      return JSON.parse(result);
    } catch (error) {
      console.log('result转换JSON失败' + error);
      return result;
    }
  }
  return result;
}

// 构建get请求参数, get请求需要把url和data拼接起来
function buildGetUrl(url, data) {
  if (!data || Object.isEmptyObject(data)) {
    return url;
  }
  if (typeof data === 'string') {
    return url + '?' + data;
  }
  if (Object.type(data) === 'json') {
    return url + '?' + Object.params(data);
  }
  return url;
}

// jsonp上传
function jsonp(url) {
  return new Promise(function (resolve, reject) {
    window.jsonCallBack = function (result) {
      resolve(result);
    };
    var JSONP = document.createElement('script');
    JSONP.type = 'text/javascript';
    JSONP.src = "".concat(url, "&callback=jsonCallBack");
    document.getElementsByTagName('head')[0].appendChild(JSONP);
    setTimeout(function () {
      document.getElementsByTagName('head')[0].removeChild(JSONP);
    }, 500);
  });
}

// 表单上传
function formUpload(url, options) {
  return new Promise(function (resolve, reject) {
    var _options$file;
    if (!(options !== null && options !== void 0 && options.file) && !(options !== null && options !== void 0 && options.fileData)) {
      // file文件框
      console.warn('没有找到options.file或者options.fileData, 无法上传');
      resolve({
        code: '0',
        message: '没有找到options.file或者options.fileData, 无法上传'
      });
      return;
    }

    // 获取数据
    var data = (options === null || options === void 0 ? void 0 : options.fileData) || (options === null || options === void 0 || (_options$file = options.file) === null || _options$file === void 0 || (_options$file = _options$file.files) === null || _options$file === void 0 ? void 0 : _options$file[0]) || null;
    if (!data) {
      console.warn('文件没有数据, 无法上传');
      return;
    }

    // 上传数据
    var formData = new FormData();
    formData.append('file', data);
    // 发送请求
    var instance = axios.create({
      withCredentials: true,
      headers: {
        'Content-type': 'multipart/form-data'
      }
    });
    instance.post(url, formData).then(function (response) {
      resolve(getResult(response));
    }).catch(function (error) {
      if (Api.fail) Api.fail(error);
      reject(error);
    });
  });
}

// 封装成Api类
var Api = {
  fail: function fail(error) {
    console.warn({
      error: error
    });
  },
  setBaseURL: function setBaseURL(baseURL) {
    axios.defaults.baseURL = baseURL;
  },
  request: function request(url) {
    var config = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    var method = config.method,
      head = config.head,
      data = config.data,
      options = _objectWithoutProperties(config, _excluded);
    // 设置method
    if (method !== 'get' && method !== 'post' && method !== 'jsonp' && method !== 'upload' && method !== 'form-upload') {
      method = 'get';
    }
    // jsonp
    if (method === 'jsonp') {
      return jsonp(url);
    }
    // 上传文件
    if (method === 'upload') {
      return formUpload(buildGetUrl(url, data), options);
    }
    // 网络数据请求
    return axios(_objectSpread({
      url: method === 'get' ? buildGetUrl(url, data) : url,
      method: method,
      headers: _objectSpread({}, head),
      data: method === 'get' ? null : data
    }, options));
  },
  post: function post(url) {
    var config = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    return this.request(url, Object.assign({}, config, {
      method: 'post'
    }));
  },
  get: function get(url) {
    var config = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    return this.request(url, Object.assign({}, config, {
      method: 'get'
    }));
  },
  all: function all(requests) {
    var _this = this;
    // requests: [{url: '', params: {}}]
    var methods = requests.map(function (request) {
      return _this.request(request.url, request.params);
    });
    return axios.all(methods);
  },
  jsonp: function jsonp(url) {
    var config = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    return this.request(url, Object.assign({}, config, {
      method: 'jsonp'
    }));
  }
};

// 响应拦截器
axios.interceptors.response.use(function (response) {
  return getResult(response);
}, function (error) {
  if (Api.fail) Api.fail(error);
  return Promise.reject(error);
});
export default Api;