function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
var _excluded = ["type", "success", "fail", "complete"],
  _excluded2 = ["needResult", "scanType", "desc", "success"];
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
// 测试使用
// import { locale, Device, Toast } from 'seedsui-react'
// 内库使用
import locale from "./../locale";
import Device from "./../Device";
import Toast from "./../Toast";
var self = null;
var Bridge = {
  /**
   * 定制功能
   */
  platform: Device.platform,
  // 自定义操作
  invoke: function invoke(api, params, callback) {
    if (!window.top.wx.invoke) {
      console.log('没有wx.invoke的方法');
      return;
    }
    window.top.wx.invoke(api, params, callback);
  },
  // 获得版本信息
  getAppVersion: function getAppVersion() {
    return Device.platformVersion;
  },
  // 判断是否是主页
  isHomePage: function isHomePage(callback, rule) {
    if (rule && window.location.href.indexOf(rule) >= 0) {
      callback(true);
      return;
    }
    callback(false);
  },
  // 返回首页
  goHome: function goHome() {
    window.history.go(-1);
  },
  // 退出到登陆页面
  logOut: function logOut() {
    console.log('logOut方法仅在app上工作');
  },
  // 打开新的窗口
  openWindow: function openWindow() {
    var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    if (params.url) window.location.href = params.url;
  },
  // 关闭窗口
  closeWindow: function closeWindow() {
    // 小程序内web-view关闭
    if (['wechatMiniprogram', 'weworkMiniprogram'].includes(Device.platform || '')) {
      window.top.wx.miniProgram.navigateBack({}); // eslint-disable-line
    }
    // 微信关闭
    window.top.wx.closeWindow(); // eslint-disable-line
  },
  // 返回监听
  onHistoryBack: function onHistoryBack(params) {
    if (typeof window.top.wx.onHistoryBack === 'function') {
      window.top.wx.onHistoryBack(params); // eslint-disable-line
    }
  },
  // 地图查看
  openLocation: function openLocation(params) {
    // 微信PC端不支持地图查看
    if (Device.device === 'pc') {
      Toast.show({
        content: locale('请在手机端微信中使用打开地图', 'SeedsUI_wechat_use_error', locale('', 'SeedsUI_openmap'))
      });
      return;
    }
    window.top.wx.openLocation(params); // eslint-disable-line
  },
  /**
   * 获取当前地理位置
   * @param {Object} params
   * @prop {String} type 'wgs84'|'gcj02'坐标类型微信默认使用国际坐标'wgs84',
   * @return {Object} {latitude: '纬度', longitude: '经度', speed:'速度', accuracy:'位置精度'}
   */
  getLocation: function getLocation() {
    var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    // 微信PC端不支持定位
    if (Device.device === 'pc') {
      var _this$getBrowserLocat;
      console.log('PC端微信定位...', params);
      (_this$getBrowserLocat = this.getBrowserLocation) === null || _this$getBrowserLocat === void 0 || _this$getBrowserLocat.call(this, params);
      return;
    }
    var _ref = params || {},
      type = _ref.type,
      _success = _ref.success,
      _fail = _ref.fail,
      _complete = _ref.complete,
      otherParams = _objectWithoutProperties(_ref, _excluded);
    self = this;
    // 调用定位
    if (self.locationTask) {
      self.locationTask.push(params);
      return;
    }
    self.locationTask = [];
    console.log('调用微信定位...', params);
    window.top.wx.getLocation(_objectSpread(_objectSpread({}, otherParams), {}, {
      // 默认为wgs84的gps坐标，如果要返回直接给openLocation用的火星坐标，可传入'gcj02'
      type: type || 'gcj02',
      success: function success(res) {
        if (res.longitude && res.latitude) {
          if (_success) _success(res);
        } else {
          if (_fail) _fail(res);
        }
        self.getLocationTask(res);
      },
      fail: function fail(res) {
        if (_fail) _fail(res);
        self.getLocationTask(res);
      },
      complete: function complete(res) {
        if (_complete) _complete(res);
      }
    }));
  },
  /*
   * 扫描二维码并返回结果
   * 返回：{resultStr:''}
   * */
  scanQRCode: function scanQRCode() {
    var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    // 微信PC端不支持扫码
    if (Device.device === 'pc') {
      Toast.show({
        content: locale('请在手机端微信中使用扫码', 'SeedsUI_wechat_use_error', locale('', 'SeedsUI_scancode'))
      });
      return;
    }
    var _ref2 = params || {},
      needResult = _ref2.needResult,
      scanType = _ref2.scanType,
      desc = _ref2.desc,
      _success2 = _ref2.success,
      othersParams = _objectWithoutProperties(_ref2, _excluded2);
    window.top.wx.scanQRCode(_objectSpread({
      needResult: needResult || 1,
      // 默认为0，扫描结果由微信处理，1则直接返回扫描结果
      scanType: scanType || ['qrCode', 'barCode'],
      desc: desc || '二维码／条码',
      success: function success(res) {
        if (!_success2) return;
        var wxRes = res;
        // 如果没有设置prefix为false或者空,则清除前缀
        if (!params.prefix) {
          if (res.resultStr.indexOf('QR,') >= 0) {
            wxRes.resultStr = res.resultStr.substring('QR,'.length);
          } else if (res.resultStr.indexOf('EAN_13,') >= 0) {
            wxRes.resultStr = res.resultStr.substring('EAN_13,'.length);
          } else if (res.resultStr.indexOf('EAN_8,') >= 0) {
            wxRes.resultStr = res.resultStr.substring('EAN_8,'.length);
          } else if (res.resultStr.indexOf('AZTEC,') >= 0) {
            wxRes.resultStr = res.resultStr.substring('AZTEC,'.length);
          } else if (res.resultStr.indexOf('DATAMATRIX,') >= 0) {
            wxRes.resultStr = res.resultStr.substring('DATAMATRIX,'.length);
          } else if (res.resultStr.indexOf('UPCA,') >= 0) {
            wxRes.resultStr = res.resultStr.substring('UPCA,'.length);
          } else if (res.resultStr.indexOf('UPCE,') >= 0) {
            wxRes.resultStr = res.resultStr.substring('UPCE,'.length);
          } else if (res.resultStr.indexOf('CODABAR,') >= 0) {
            wxRes.resultStr = res.resultStr.substring('CODABAR,'.length);
          } else if (res.resultStr.indexOf('CODE_39,') >= 0) {
            wxRes.resultStr = res.resultStr.substring('CODE_39,'.length);
          } else if (res.resultStr.indexOf('CODE_93,') >= 0) {
            wxRes.resultStr = res.resultStr.substring('CODE_93,'.length);
          } else if (res.resultStr.indexOf('CODE_128,') >= 0) {
            wxRes.resultStr = res.resultStr.substring('CODE_128,'.length);
          } else if (res.resultStr.indexOf('ITF,') >= 0) {
            wxRes.resultStr = res.resultStr.substring('ITF,'.length);
          } else if (res.resultStr.indexOf('MAXICODE,') >= 0) {
            wxRes.resultStr = res.resultStr.substring('MAXICODE,'.length);
          } else if (res.resultStr.indexOf('PDF_417,') >= 0) {
            wxRes.resultStr = res.resultStr.substring('PDF_417,'.length);
          } else if (res.resultStr.indexOf('RSS_14,') >= 0) {
            wxRes.resultStr = res.resultStr.substring('RSS_14,'.length);
          } else if (res.resultStr.indexOf('RSSEXPANDED,') >= 0) {
            wxRes.resultStr = res.resultStr.substring('RSSEXPANDED,'.length);
          }
        }
        // 回调
        _success2(wxRes);
      }
    }, othersParams));
  },
  chooseImage: function chooseImage(params) {
    // 微信PC端不支持扫码
    if (Device.device === 'pc') {
      var _params$fail;
      var errMsg = locale('请在手机端微信中使用选择图片', 'SeedsUI_wechat_use_error', locale('', 'SeedsUI_chooseimage'));
      Toast.show({
        content: errMsg
      });
      params === null || params === void 0 || (_params$fail = params.fail) === null || _params$fail === void 0 || _params$fail.call(params, {
        errCode: 'PC_NOT_IMPLENMENTED',
        errMsg: errMsg
      });
      return;
    }
    window.top.wx.chooseImage(params);
  },
  uploadImage: function uploadImage(params) {
    // 微信PC端不支持扫码
    if (Device.device === 'pc') {
      var _params$fail2;
      var errMsg = locale('请在手机端微信中使用上传图片', 'SeedsUI_wechat_use_error', locale('', 'SeedsUI_uploadimage'));
      Toast.show({
        content: errMsg
      });
      params === null || params === void 0 || (_params$fail2 = params.fail) === null || _params$fail2 === void 0 || _params$fail2.call(params, {
        errCode: 'PC_NOT_IMPLENMENTED',
        errMsg: errMsg
      });
      return;
    }
    window.top.wx.uploadImage(params);
  },
  previewImage: function previewImage(params) {
    // 微信PC端不支持扫码
    if (Device.device === 'pc') {
      Toast.show({
        content: locale('请在手机端微信中使用照片预览', 'SeedsUI_wechat_use_error', locale('', 'SeedsUI_previewimage'))
      });
      return;
    }
    window.top.wx.previewImage(params);
  },
  /**
   * 文件操作: 预览文件
   * @param {Object} params
   * params: {
   *  url: '', // 需要预览文件的地址(必填，可以使用相对路径)
   *  name: '', // 需要预览文件的文件名(不填的话取url的最后部分)
   *  size: 1048576 // 需要预览文件的字节大小(必填)
   * }
   */
  previewFile: function previewFile(params) {
    // 微信PC端不支持预览文件
    if (Device.device === 'pc') {
      Toast.show({
        content: locale('请在手机端微信中使用文件预览', 'SeedsUI_wechat_use_error', locale('', 'SeedsUI_previewfile'))
      });
      return;
    }
    window.top.wx.previewFile(params);
  }
};
export default Bridge;