function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it.return != null) it.return(); } finally { if (didErr) throw err; } } }; }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
import getWeekDates from "./getWeekDates";
import getDateRowIndex from "./getDateRowIndex";

// 方便渲染, 三维化dates数组：3页6行7列
function getSplitDates(dates, _ref) {
  var activeDate = _ref.activeDate,
    type = _ref.type;
  var result = [];
  if (!activeDate || !(dates !== null && dates !== void 0 && dates.length)) return result;
  // 共3页，每页42个
  for (var i = 0; i < dates.length; i += 42) {
    var page = dates.slice(i, i + 42);
    var pageArray = [];
    // 每页6行，每行7个
    for (var j = 0; j < page.length; j += 7) {
      var row = page.slice(j, j + 7);
      pageArray.push(row);
    }
    result.push(pageArray);
  }

  // 周需要替换同行上周和下周的数据
  if (typeof type === 'number' || type === 'week') {
    var activeRowIndex = getDateRowIndex(activeDate);

    // 上周和下周数据
    var prevWeek = getWeekDates(activeDate, -7);
    var nextWeek = getWeekDates(activeDate, 7);

    // 平替周行的上月和下月，保证滑动时显示正常
    var _iterator = _createForOfIteratorHelper(result.entries()),
      _step;
    try {
      for (_iterator.s(); !(_step = _iterator.n()).done;) {
        var _step$value = _slicedToArray(_step.value, 2),
          index = _step$value[0],
          _page = _step$value[1];
        if (index === 1) continue;
        for (var rowIndex = 0; rowIndex < _page.length; rowIndex++) {
          if (rowIndex === activeRowIndex) {
            // 替换上周数据
            if (index === 0) {
              _page[rowIndex] = prevWeek;
            }
            // 替换下周数据
            else if (index === 2) {
              _page[rowIndex] = nextWeek;
            }
          }
        }
      }
    } catch (err) {
      _iterator.e(err);
    } finally {
      _iterator.f();
    }
  }
  return result;
}
export default getSplitDates;