// 校验选中日期是否正确
function validate(jumpDate, _ref) {
  var min = _ref.min,
    max = _ref.max,
    onError = _ref.onError;
  if (jumpDate instanceof Date === false) {
    return;
  }
  // 如果最小值大于等于最大值则无法生效
  if (min instanceof Date && max instanceof Date && min.compareDate(max) >= 1) {
    var errMsg = '最小值min' + min.format('YYYY年MM月DD日') + '不能大于等于max' + max.format('YYYY年MM月DD日');
    console.log('SeedsUI Warn：' + errMsg);
    if (onError) onError({
      errMsg: errMsg,
      min: min,
      max: max,
      value: jumpDate,
      instance: s
    });
    return false;
  }
  // 小于最小值
  if (min instanceof Date && jumpDate.compareDate(min) === -1) {
    var _errMsg = '禁止访问' + min.format('YYYY年MM月DD日') + '前的日期';
    console.log('SeedsUI Warn：' + _errMsg);
    if (onError) onError({
      errMsg: _errMsg,
      min: min,
      value: jumpDate,
      instance: s
    });
    return -1;
  }
  // 大于最大值
  if (max instanceof Date && jumpDate.compareDate(max) === 1) {
    var _errMsg2 = '禁止访问' + max.format('YYYY年MM月DD日') + '后的日期';
    console.log('SeedsUI Warn：' + _errMsg2);
    if (onError) onError({
      errMsg: _errMsg2,
      max: max,
      value: jumpDate,
      instance: s
    });
    return 1;
  }
  return true;
}