var _excluded = ["avatar", "caption", "captionProps", "contentProps", "bubbleProps", "children"];
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React, { forwardRef, useRef, useImperativeHandle } from 'react';
var Chat = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var avatar = _ref.avatar,
    caption = _ref.caption,
    _ref$captionProps = _ref.captionProps,
    captionProps = _ref$captionProps === void 0 ? {} : _ref$captionProps,
    _ref$contentProps = _ref.contentProps,
    contentProps = _ref$contentProps === void 0 ? {} : _ref$contentProps,
    _ref$bubbleProps = _ref.bubbleProps,
    bubbleProps = _ref$bubbleProps === void 0 ? {} : _ref$bubbleProps,
    children = _ref.children,
    props = _objectWithoutProperties(_ref, _excluded);
  // 节点
  var rootRef = useRef(null);
  useImperativeHandle(ref, function () {
    return {
      rootDOM: rootRef.current,
      getRootDOM: function getRootDOM() {
        return rootRef.current;
      }
    };
  });
  return /*#__PURE__*/React.createElement("div", _extends({}, props, {
    className: "chat".concat(props.className ? ' ' + props.className : ''),
    ref: rootRef
  }), avatar, /*#__PURE__*/React.createElement("div", _extends({}, contentProps, {
    className: "chat-content".concat(contentProps.className ? ' ' + contentProps.className : '')
  }), caption && /*#__PURE__*/React.createElement("div", _extends({}, captionProps, {
    className: "chat-content-caption".concat(captionProps.className ? ' ' + captionProps.className : '')
  }), caption), /*#__PURE__*/React.createElement("div", _extends({}, bubbleProps, {
    className: "chat-content-bubble".concat(bubbleProps.className ? ' ' + bubbleProps.className : '')
  }), children)));
});
export default Chat;