var _excluded = ["type", "value", "checked", "readOnly", "disabled", "inputProps", "captionProps", "children", "onChange"];
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React, { forwardRef, useRef, useImperativeHandle } from 'react';

// 复选框
var Checkbox = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var type = _ref.type,
    value = _ref.value,
    checked = _ref.checked,
    readOnly = _ref.readOnly,
    disabled = _ref.disabled,
    _ref$inputProps = _ref.inputProps,
    inputProps = _ref$inputProps === void 0 ? {} : _ref$inputProps,
    _ref$captionProps = _ref.captionProps,
    captionProps = _ref$captionProps === void 0 ? {} : _ref$captionProps,
    children = _ref.children,
    onChange = _ref.onChange,
    props = _objectWithoutProperties(_ref, _excluded);
  // 节点
  var rootRef = useRef(null);
  var inputRef = useRef(null);
  useImperativeHandle(ref, function () {
    return {
      rootDOM: rootRef.current,
      inputDOM: inputRef.current,
      getRootDOM: function getRootDOM() {
        return rootRef.current;
      },
      getInputDOM: function getInputDOM() {
        return inputRef.current;
      }
    };
  });

  // 点击回调
  function handleClick(e) {
    if (disabled || readOnly) return;
    if (onChange) onChange(e.currentTarget.getAttribute('data-checked') !== 'true');
  }

  // 类型样式前缀
  var typeClassPrefix = type === 'radio' ? 'radio' : 'checkbox';
  return /*#__PURE__*/React.createElement("div", _extends({}, props, {
    onClick: handleClick,
    disabled: disabled,
    readOnly: readOnly,
    "data-checked": checked,
    "data-value": value,
    className: "".concat(typeClassPrefix).concat(props.className ? ' ' + props.className : ''),
    ref: rootRef
  }), /*#__PURE__*/React.createElement("span", _extends({
    ref: inputRef
  }, inputProps, {
    className: "".concat(typeClassPrefix, "-input").concat(inputProps.className ? ' ' + inputProps.className : '')
  })), (children || (captionProps === null || captionProps === void 0 ? void 0 : captionProps.caption)) && /*#__PURE__*/React.createElement("div", _extends({}, captionProps, {
    className: "".concat(typeClassPrefix, "-caption").concat(captionProps.className ? ' ' + captionProps.className : '')
  }), captionProps === null || captionProps === void 0 ? void 0 : captionProps.caption, children));
});
export default Checkbox;