var _excluded = ["duration", "from", "to", "thousandth", "suffix", "autoPlay"];
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React, { forwardRef, useRef, useImperativeHandle, useEffect } from 'react';
import { Counter as Instance } from "./instance.js";

// 计数器
var Counter = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var _ref$duration = _ref.duration,
    duration = _ref$duration === void 0 ? 5000 : _ref$duration,
    from = _ref.from,
    to = _ref.to,
    thousandth = _ref.thousandth,
    _ref$suffix = _ref.suffix,
    suffix = _ref$suffix === void 0 ? '' : _ref$suffix,
    _ref$autoPlay = _ref.autoPlay,
    autoPlay = _ref$autoPlay === void 0 ? true : _ref$autoPlay,
    props = _objectWithoutProperties(_ref, _excluded);
  var rootRef = useRef(null);
  var instance = useRef(null);
  useImperativeHandle(ref, function () {
    return {
      rootDOM: rootRef.current,
      instance: instance.current,
      getRootDOM: function getRootDOM() {
        return rootRef.current;
      },
      getInstance: function getInstance() {
        return instance.current;
      }
    };
  });
  useEffect(function () {
    if (instance.current) return;
    if (!isNaN(from) && !isNaN(to)) {
      initInstance();
    }
  }, [from, to]); // eslint-disable-line

  function initInstance() {
    if (!(rootRef !== null && rootRef !== void 0 && rootRef.current)) return;
    if (!instance.current) {
      instance.current = new Instance(rootRef.current);
    }
    if (autoPlay) {
      instance.current.play();
    }
  }
  return /*#__PURE__*/React.createElement("span", _extends({}, props, {
    className: "counter".concat(props.className ? ' ' + props.className : ''),
    "data-duration": duration,
    "data-from": from || 0,
    "data-to": to || 0,
    "data-suffix": suffix,
    ref: rootRef
  }), !isNaN(thousandth) && Math.Calc.toThousandth(thousandth || 0) + suffix);
});
export default Counter;