import { getDateDisplayValue } from "./../utils";
import getActiveOption from "./../RangeMain/SelectorMain/getActiveOption";

// 显示名称
function getRangeDisplayValue(_ref) {
  var format = _ref.format,
    ranges = _ref.ranges,
    type = _ref.type,
    value = _ref.value,
    separator = _ref.separator,
    currentActiveKey = _ref.currentActiveKey;
  if (!Array.isArray(value) || value.length !== 2) {
    return '';
  }
  var start = value[0];
  var end = value[1];
  if (Object.isDate(start) === false || Object.isDate(end) === false) {
    return '';
  }
  var displayValue = [];

  // 显示别名, 自定义没有别名
  var activeOption = getActiveOption(value, ranges, {
    format: format,
    currentActiveKey: currentActiveKey
  });
  if (Array.isArray(activeOption === null || activeOption === void 0 ? void 0 : activeOption.value)) {
    return activeOption.name;
  }

  // 显示日期
  displayValue.push(getDateDisplayValue({
    format: format,
    type: type,
    value: start
  }));
  displayValue.push(getDateDisplayValue({
    format: format,
    type: type,
    value: end
  }));
  return displayValue.join(separator || ' ~ ');
}
export default getRangeDisplayValue;