import Toast from "./../../../../Toast";
import locale from "./../../../../locale";
// 测试使用
// import Toast from 'seedsui-react/lib/Toast'
// import locale from 'seedsui-react/lib/locale'

import getRangeDates from "./../../getRangeDates";

// 计算区间, 区间内
function validateRangeLimit(value, _ref) {
  var dateRangeLimit = _ref.dateRangeLimit,
    onError = _ref.onError;
  if (!dateRangeLimit) return value;
  var _getRangeDates = getRangeDates(value),
    startDate = _getRangeDates.startDate,
    endDate = _getRangeDates.endDate;
  if (!startDate || !endDate) {
    return value;
  }
  var diff = startDate.diff(endDate);
  if (diff.days > dateRangeLimit) {
    var errMsg = locale("\u65E5\u671F\u533A\u95F4\u4E0D\u80FD\u8D85\u8FC7".concat(dateRangeLimit, "\u5929"), 'SeedsUI_dateragne_limit_error', [dateRangeLimit]);
    if (onError) {
      onError({
        errMsg: errMsg,
        dateRangeLimit: dateRangeLimit,
        value: value
      });
    } else {
      Toast.show({
        content: errMsg,
        maskClickable: true
      });
    }
    return false;
  }
  return value;
}
export default validateRangeLimit;