var _excluded = ["thead", "tbody", "tfoot", "frozenThead", "frozenTfoot", "frozenLeft", "frozenRight", "onBottomRefresh", "children"];
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React, { forwardRef, useRef, useImperativeHandle, useEffect, useState } from 'react';
import useSyncCallback from "./../useSyncCallback";
import Instance from "./instance.js";
var updateSuccess = null;

// 函数组件因为没有实例, 所以也没有ref, 必须通过forwardRef回调ref
var FixTable = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var thead = _ref.thead,
    tbody = _ref.tbody,
    tfoot = _ref.tfoot,
    _ref$frozenThead = _ref.frozenThead,
    frozenThead = _ref$frozenThead === void 0 ? false : _ref$frozenThead,
    _ref$frozenTfoot = _ref.frozenTfoot,
    frozenTfoot = _ref$frozenTfoot === void 0 ? false : _ref$frozenTfoot,
    _ref$frozenLeft = _ref.frozenLeft,
    frozenLeft = _ref$frozenLeft === void 0 ? [] : _ref$frozenLeft,
    _ref$frozenRight = _ref.frozenRight,
    frozenRight = _ref$frozenRight === void 0 ? [] : _ref$frozenRight,
    onBottomRefresh = _ref.onBottomRefresh,
    children = _ref.children,
    others = _objectWithoutProperties(_ref, _excluded);
  var _useState = useState(null),
    _useState2 = _slicedToArray(_useState, 2),
    forceUpdate = _useState2[0],
    setForceUpdate = _useState2[1];
  var rootRef = useRef(null);
  var instance = useRef({
    getContainer: function getContainer() {
      return rootRef.current;
    },
    update: handleUpdateRemove,
    updateContainerSize: handleUpdateContainerSize
  });
  useImperativeHandle(ref, function () {
    return {
      rootDOM: rootRef.current,
      instance: instance.current,
      getRootDOM: function getRootDOM() {
        return rootRef.current;
      },
      getInstance: function getInstance() {
        return instance.current;
      }
    };
  });

  // 更新容器
  useEffect(function () {
    if (forceUpdate === 1 || !rootRef || !rootRef.current) return;
    // console.log('更新容器', rootRef.current)
    // rootRef.current.scrollTop = 0
    // rootRef.current.scrollLeft = 0
    // 更新容器尺寸
    handleUpdateContainerSize();
  }, [forceUpdate]); // eslint-disable-line

  // 更新容器尺寸
  function handleUpdateContainerSize() {
    // 更新容器尺寸
    Instance.updateContainerSize(rootRef.current, frozenLeft, frozenRight);
    // 滚动修改左右滚动样式, 和底部加载
    Instance.onScroll(rootRef.current, onBottomRefresh);
  }

  // 用显隐强制更新
  function handleUpdateRemove(success) {
    updateSuccess = success;
    setForceUpdate(1);
    handleUpdateRecovery();
  }
  var handleUpdateRecovery = useSyncCallback(function () {
    setForceUpdate(0);
    handleUpdateComplete();
  });
  var handleUpdateComplete = useSyncCallback(function () {
    if (typeof updateSuccess === 'function') updateSuccess(instance.current);
  });

  // 滚动修改左右滚动样式, 和底部加载
  function handleScroll(e) {
    Instance.onScroll(e.currentTarget, onBottomRefresh);
  }
  return /*#__PURE__*/React.createElement("div", _extends({}, others, {
    className: 'fixtable' + (others.className ? ' ' + others.className : ''),
    onScroll: handleScroll,
    ref: rootRef
  }), !tbody || forceUpdate === 1 ? null : /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("table", {
    className: "fixtable-table".concat(frozenThead ? ' frozen-thead' : '').concat(frozenTfoot ? ' frozen-tfoot' : '')
  }, thead, tbody, tfoot), children));
});
export default FixTable;