function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it.return != null) it.return(); } finally { if (didErr) throw err; } } }; }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
var Imgmark = function Imgmark(container, params) {
  /* ----------------------
  Model
  ---------------------- */
  var defaults = {
    loadingClass: 'imgmark-loading',
    errorClass: 'imgmark-error',
    activeClass: 'active',
    src: '',
    isDrawSrc: true,
    // 是否连同背景一起绘制到canvas上
    data: [],
    strokeStyle: '#00ff00',
    lineWidth: 3,
    suffix: 'image/png',
    quality: 0.92

    /*
    Callbacks:
    onSuccess: function(Imgmark)
    onError: function(e, {errMsg: ''})
    */
  };
  params = params || {};
  for (var def in defaults) {
    if (params[def] === undefined) {
      params[def] = defaults[def];
    }
  }
  var s = this;
  s.params = params;
  s.container = typeof container === 'string' ? document.querySelector(container) : container;
  if (!s.container) {
    console.log('SeedsUI Error : ImgMark container不存在，请检查页面中是否有此元素');
    return;
  }
  s.loadingContainer = s.container.parentNode.querySelector('.' + s.params.loadingClass) || null;
  s.errorContainer = s.container.parentNode.querySelector('.' + s.params.errorClass) || null;
  s.ctx = s.container.getContext('2d');
  s.stageInfo = s.container.getBoundingClientRect();
  s.path = {
    beginX: 0,
    beginY: 0,
    endX: 0,
    endY: 0
  };

  /* ----------------------
  Method
  ---------------------- */
  // 清除
  s.clear = function () {
    s.ctx.clearRect(0, 0, s.container.width, s.container.height);
  };
  // 保存图片为base64
  s.save = function () {
    try {
      return s.container.toDataURL(s.params.suffix, s.params.quality);
    } catch (error) {
      console.error(error);
      return null;
    }
  };
  // 绘制图片
  s.draw = function (img, data, isDrawSrc) {
    if (!img) {
      console.log('SeedsUI Error:ImgMark执行draw缺少img');
      return;
    }
    if (!data) {
      console.log('SeedsUI Error:ImgMark执行draw缺少img');
      return;
    }
    if (isDrawSrc) {
      s.ctx.drawImage(img, 0, 0, img.width, img.height, 0, 0, img.width, img.height);
    }
    var _iterator = _createForOfIteratorHelper(data),
      _step;
    try {
      for (_iterator.s(); !(_step = _iterator.n()).done;) {
        var item = _step.value;
        if (item.strokeStyle) s.ctx.strokeStyle = item.strokeStyle;else s.ctx.strokeStyle = s.params.strokeStyle;
        if (item.lineWidth) s.ctx.lineWidth = item.lineWidth;else s.ctx.lineWidth = s.params.lineWidth;
        if (item.setLineDash) s.ctx.setLineDash(item.setLineDash);
        s.ctx.strokeRect(item.x1, item.y1, item.x2 - item.x1, item.y2 - item.y1);
      }
    } catch (err) {
      _iterator.e(err);
    } finally {
      _iterator.f();
    }
  };
  s.update = function () {
    if (s.params.src) {
      var img = new Image();
      img.src = s.params.src;
      img.addEventListener('load', s.onLoad, false);
      img.addEventListener('error', s.onError, false);
    }
  };
  // 更新params
  s.updateParams = function () {
    var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    for (var param in params) {
      s.params[param] = params[param];
    }
    s.update();
  };
  /* ----------------------
  Events
  ---------------------- */
  s.onLoad = function (e) {
    var target = e.target;
    // 显隐
    if (s.loadingContainer) s.loadingContainer.classList.remove(s.params.activeClass);
    if (s.errorContainer) s.errorContainer.classList.remove(s.params.activeClass);
    s.container.classList.add(s.params.activeClass);
    // 绘图
    s.container.width = target.width;
    s.container.height = target.height;
    s.draw(target, s.params.data, s.params.isDrawSrc);
    // 缩小
    var scale = s.params.height / target.height;
    s.container.style.WebkitTransform = "scale(".concat(scale, ") translate(-50%,-50%)");
    s.container.style.WebkitTransformOrigin = "0 0";
    // Callback
    s.event = e;
    if (s.params.onSuccess) s.params.onSuccess(s);
  };
  s.onError = function (e) {
    if (s.loadingContainer) s.loadingContainer.classList.remove(s.params.activeClass);
    if (s.errorContainer) s.errorContainer.classList.add(s.params.activeClass);
    s.container.classList.remove(s.params.activeClass);
    // Callback
    s.event = e;
    if (s.params.onError) s.params.onError(e, {
      errMsg: ''
    });
  };
  // 主函数
  s.init = function () {
    s.update();
  };
  s.init();
};
export default Imgmark;