var _excluded = ["value", "min", "max", "onChange", "onError"];
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React, { forwardRef, useRef, useImperativeHandle } from 'react';
import Star from "./../../Star";
import locale from "./../../locale";
var InputStar = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var _ref$value = _ref.value,
    value = _ref$value === void 0 ? 0 : _ref$value,
    _ref$min = _ref.min,
    min = _ref$min === void 0 ? 0 : _ref$min,
    _ref$max = _ref.max,
    max = _ref$max === void 0 ? 5 : _ref$max,
    onChange = _ref.onChange,
    onError = _ref.onError,
    props = _objectWithoutProperties(_ref, _excluded);
  if (typeof max !== 'number' || max <= 0) {
    max = 5;
  }
  var rootRef = useRef(null);
  useImperativeHandle(ref, function () {
    return {
      rootDOM: rootRef.current,
      getRootDOM: function getRootDOM() {
        return rootRef.current;
      }
    };
  });
  function handleChange(e, newValue) {
    if (newValue < min) {
      if (onError) {
        onError({
          errMsg: locale("\u4E0D\u80FD\u5C0F\u4E8E".concat(min, "\u9897\u661F"), 'SeedsUI_min_star_error', [min]),
          min: min,
          value: newValue
        });
        return;
      }
      newValue = min;
    }
    if (onChange) onChange(newValue);
    e.stopPropagation();
  }
  var stars = [];
  for (var i = 1; i <= max; i++) {
    stars.push(i);
  }
  var current = value;
  if (current < min) current = min;
  return /*#__PURE__*/React.createElement("div", _extends({}, props, {
    className: "input-star".concat(props.className ? ' ' + props.className : ''),
    ref: rootRef
  }), stars.map(function (index) {
    return /*#__PURE__*/React.createElement(Star, {
      onClick: function onClick(e) {
        handleChange(e, index);
      },
      key: index,
      className: index <= current ? 'active' : ''
    });
  }));
});
export default InputStar;