var _excluded = ["min", "max", "value", "onChange", "onError"];
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React, { forwardRef, useContext } from 'react';
import Star from "./../Star";
import Context from "../Context/instance.js";

/**
 * @deprecated since version 5.2.8
 * 请使用Input.Star
 */
var InputStar = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var _ref$min = _ref.min,
    min = _ref$min === void 0 ? 0 : _ref$min,
    _ref$max = _ref.max,
    max = _ref$max === void 0 ? 5 : _ref$max,
    _ref$value = _ref.value,
    value = _ref$value === void 0 ? 0 : _ref$value,
    onChange = _ref.onChange,
    onError = _ref.onError,
    others = _objectWithoutProperties(_ref, _excluded);
  // context
  var context = useContext(Context) || {};
  var locale = context.locale || function (remark) {
    return remark || '';
  };
  function changeHandler(e, argNum) {
    var num = argNum;
    if (num < min) {
      if (onError) {
        onError(e, {
          errMsg: locale("\u4E0D\u80FD\u5C0F\u4E8E".concat(min, "\u9897\u661F"), 'SeedsUI_min_star_error', [min]),
          select: num,
          min: min,
          value: min,
          event: e
        });
      }
      num = min;
    }
    if (onChange) onChange(e, num);
  }
  var stars = [];
  for (var i = 1; i <= max; i++) {
    stars.push(i);
  }
  var current = value;
  if (current < min) current = min;
  return /*#__PURE__*/React.createElement("div", _extends({
    ref: ref
  }, others, {
    className: "input-star".concat(others.className ? ' ' + others.className : '')
  }), stars.map(function (index) {
    return /*#__PURE__*/React.createElement(Star, {
      onClick: function onClick(e) {
        changeHandler(e, index);
      },
      key: index,
      className: index <= current ? 'active' : ''
    });
  }));
});
export default InputStar;