function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
/* Rect class -- describes a rectangle with two points, usually
   top left and bottom right. It allows the second set of coordinates
   to be described as either w/h or x2/y2 and allows getting and
   setting of those values such that the object values will always be
   consistent with the latest input. It should be noted that it does not
   attempt to keep these points normalized. That is, you should expect
   to see the actual w/h properties to sometimes be negative values.
   To normalize the values, use the normalize method, which will return
   a new Rect object with normalized values.
*/
var Rect = /*#__PURE__*/function () {
  function Rect() {
    _classCallCheck(this, Rect);
    this.x = 0;
    this.y = 0;
    this.w = 0;
    this.h = 0;
  }
  _createClass(Rect, [{
    key: "x1",
    set: function set(v) {
      this.w = this.x2 - v;
      this.x = v;
    }
  }, {
    key: "y1",
    set: function set(v) {
      this.h = this.y2 - v;
      this.y = v;
    }
  }, {
    key: "x2",
    get: function get() {
      return this.x + this.w;
    },
    set: function set(x) {
      this.w = x - this.x;
    }
  }, {
    key: "y2",
    get: function get() {
      return this.y + this.h;
    },
    set: function set(y) {
      this.h = y - this.y;
    }
  }, {
    key: "aspect",
    get: function get() {
      return this.w / this.h;
    }
  }, {
    key: "round",
    value: function round() {
      return Rect.create(Math.round(this.x), Math.round(this.y), Math.round(this.w), Math.round(this.h));
    }
  }, {
    key: "normalize",
    value: function normalize() {
      var _ref = [Math.min(this.x, this.x2), Math.min(this.y, this.y2), Math.max(this.x, this.x2), Math.max(this.y, this.y2)],
        x1 = _ref[0],
        y1 = _ref[1],
        x2 = _ref[2],
        y2 = _ref[3];
      return Rect.create(x1, y1, x2 - x1, y2 - y1);
    }
  }, {
    key: "rebound",
    value: function rebound(w, h) {
      var rect = this.normalize();
      if (rect.x < 0) rect.x = 0;
      if (rect.y < 0) rect.y = 0;
      if (rect.x2 > w) rect.x = w - rect.w;
      if (rect.y2 > h) rect.y = h - rect.h;
      return rect;
    }
  }, {
    key: "scale",
    value: function scale(x, y) {
      y = y || x;
      return Rect.create(this.x, this.y, this.w * x, this.h * y);
    }
  }, {
    key: "center",
    value: function center(w, h) {
      return Rect.create((w - this.w) / 2, (h - this.h) / 2, this.w, this.h);
    }
  }, {
    key: "toArray",
    value: function toArray() {
      return [this.x, this.y, this.w, this.h];
    }
  }]);
  return Rect;
}();
Rect.fromPoints = function (p1, p2) {
  var _ref2 = [Math.min(p1[0], p2[0]), Math.min(p1[1], p2[1]), Math.max(p1[0], p2[0]), Math.max(p1[1], p2[1])],
    x1 = _ref2[0],
    y1 = _ref2[1],
    x2 = _ref2[2],
    y2 = _ref2[3];
  return Rect.create(x1, y1, x2 - x1, y2 - y1);
};
Rect.create = function () {
  var x = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
  var y = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
  var w = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 0;
  var h = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 0;
  var c = new Rect();
  c.x = x;
  c.y = y;
  c.w = w;
  c.h = h;
  return c;
};
Rect.from = function (el) {
  if (Array.isArray(el)) return Rect.fromArray(el);
  var c = new Rect();
  c.x = el.offsetLeft;
  c.y = el.offsetTop;
  c.w = el.offsetWidth;
  c.h = el.offsetHeight;
  return c;
};
Rect.fromArray = function (args) {
  if (args.length === 4) return Rect.create.apply(this, args);else if (args.length === 2) return Rect.fromPoints(args[0], args[1]);else throw 'fromArray method problem';
};
Rect.sizeOf = function (el, y) {
  if (y) return Rect.create(0, 0, el, y);
  var c = new Rect();
  c.w = el.offsetWidth;
  c.h = el.offsetHeight;
  return c;
};
Rect.getMax = function (w, h, aspect) {
  if (w / h > aspect) return [h * aspect, h];else return [w, w / aspect];
};
Rect.fromPoint = function (point, w, h) {
  var quad = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 'br';
  var c = new Rect();
  c.x = point[0];
  c.y = point[1];
  switch (quad) {
    case 'br':
      c.x2 = c.x + w;
      c.y2 = c.y + h;
      break;
    case 'bl':
      c.x2 = c.x - w;
      c.y2 = c.y + h;
      break;
    case 'tl':
      c.x2 = c.x - w;
      c.y2 = c.y - h;
      break;
    case 'tr':
      c.x2 = c.x + w;
      c.y2 = c.y - h;
      break;
  }
  return c;
};
export default Rect;