var _excluded = ["children"];
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React, { useEffect, useImperativeHandle, forwardRef, useRef } from 'react';
var Footer = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var children = _ref.children,
    props = _objectWithoutProperties(_ref, _excluded);
  var rootRef = useRef(null);

  // Set safe area
  useEffect(function () {
    // 若父级元素有safe-area, 启用安全区
    var footerDOM = rootRef.current;
    var layoutDOM = footerDOM === null || footerDOM === void 0 ? void 0 : footerDOM.parentNode;
    if (layoutDOM && layoutDOM.classList.contains('safe-area')) {
      // 删除主体安全区
      var mainDOM = layoutDOM.querySelector('.layout-main.safe-area');
      if (mainDOM) mainDOM.classList.add('clear-safe-area');
      // 底部加上安全区
      footerDOM.classList.add('safe-area', 'border-bottom');
    }
    return function () {
      // 还原主体安全区
      var mainDOM = layoutDOM.querySelector('.layout-main.safe-area');
      if (mainDOM) mainDOM.classList.remove('clear-safe-area');
    };
  }, []);

  // 节点
  useImperativeHandle(ref, function () {
    return {
      rootDOM: rootRef.current,
      getRootDOM: function getRootDOM() {
        return rootRef.current;
      }
    };
  });
  return /*#__PURE__*/React.createElement("footer", _extends({}, props, {
    className: "layout-footer".concat(props.className ? ' ' + props.className : ''),
    ref: rootRef
  }), children);
});
export default Footer;