var _excluded = ["portal", "type", "maskProps", "icon", "iconProps", "captionProps", "content", "children"],
  _excluded2 = ["caption"];
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React, { forwardRef, useRef, useImperativeHandle } from 'react';
import { createPortal } from 'react-dom';
// 测试使用
// import { locale } from 'seedsui-react'
// 内库使用
import locale from "./../locale"; // 国际化数据

var Loading = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var portal = _ref.portal,
    _ref$type = _ref.type,
    type = _ref$type === void 0 ? 'floating' : _ref$type,
    _ref$maskProps = _ref.maskProps,
    maskProps = _ref$maskProps === void 0 ? {} : _ref$maskProps,
    icon = _ref.icon,
    iconProps = _ref.iconProps,
    _ref$captionProps = _ref.captionProps,
    captionProps = _ref$captionProps === void 0 ? {} : _ref$captionProps,
    content = _ref.content,
    children = _ref.children,
    props = _objectWithoutProperties(_ref, _excluded);
  var rootRef = useRef(null);
  var containerRef = useRef(null);
  useImperativeHandle(ref, function () {
    return {
      rootDOM: rootRef.current,
      containerDOM: containerRef.current,
      getRootDOM: function getRootDOM() {
        return rootRef.current;
      },
      getContainerDOM: function getContainerDOM() {
        return containerRef.current;
      }
    };
  });
  var _captionProps$caption = captionProps.caption,
    caption = _captionProps$caption === void 0 ? locale('加载中...', 'SeedsUI_loading') : _captionProps$caption,
    otherCaptionProps = _objectWithoutProperties(captionProps, _excluded2);
  if (typeof content === 'string') {
    caption = content;
  }
  var contentNode = null;
  if (type === 'custom') {
    // 自定义样式
    contentNode = /*#__PURE__*/React.createElement("div", _extends({
      ref: containerRef
    }, props, {
      className: "loading-custom".concat(props.className ? ' ' + props.className : '')
    }), icon && icon, iconProps && /*#__PURE__*/React.createElement("span", _extends({}, iconProps, {
      className: "loading-custom-icon".concat(iconProps.className ? ' ' + iconProps.className : '')
    })), caption && /*#__PURE__*/React.createElement("p", _extends({}, otherCaptionProps, {
      className: "loading-custom-caption".concat(otherCaptionProps.className ? ' ' + otherCaptionProps.className : '')
    }), caption));
  } else if (type === 'filling') {
    // 填料环
    contentNode = /*#__PURE__*/React.createElement("div", _extends({
      ref: containerRef
    }, props, {
      className: "loading-filling active".concat(props.className ? ' ' + props.className : '')
    }), /*#__PURE__*/React.createElement("div", {
      className: "loading-filling-icon"
    }));
  } else if (type === 'floating') {
    // 流光
    contentNode = /*#__PURE__*/React.createElement("div", _extends({
      ref: containerRef
    }, props, {
      className: "loading-floating animated".concat(props.className ? ' ' + props.className : '')
    }), /*#__PURE__*/React.createElement("div", {
      className: "loading-floating-icon"
    }, /*#__PURE__*/React.createElement("div", {
      className: "loading-floating-blade"
    }), /*#__PURE__*/React.createElement("div", {
      className: "loading-floating-blade"
    }), /*#__PURE__*/React.createElement("div", {
      className: "loading-floating-blade"
    }), /*#__PURE__*/React.createElement("div", {
      className: "loading-floating-blade"
    }), /*#__PURE__*/React.createElement("div", {
      className: "loading-floating-blade"
    }), /*#__PURE__*/React.createElement("div", {
      className: "loading-floating-blade"
    }), /*#__PURE__*/React.createElement("div", {
      className: "loading-floating-blade"
    }), /*#__PURE__*/React.createElement("div", {
      className: "loading-floating-blade"
    }), /*#__PURE__*/React.createElement("div", {
      className: "loading-floating-blade"
    }), /*#__PURE__*/React.createElement("div", {
      className: "loading-floating-blade"
    }), /*#__PURE__*/React.createElement("div", {
      className: "loading-floating-blade"
    }), /*#__PURE__*/React.createElement("div", {
      className: "loading-floating-blade"
    })), caption && /*#__PURE__*/React.createElement("div", _extends({}, otherCaptionProps, {
      className: "loading-floating-caption".concat(otherCaptionProps.className ? ' ' + otherCaptionProps.className : '')
    }), caption));
  }

  // 组合Node
  var Node = /*#__PURE__*/React.createElement("div", _extends({}, maskProps, {
    className: 'loading-mask mask active' + (maskProps.className ? ' ' + maskProps.className : ''),
    ref: rootRef
  }), contentNode, children);
  if (portal) {
    return /*#__PURE__*/createPortal(Node, portal);
  }
  return Node;
});
export default Loading;