import React from 'react';
import { activeItemTarget } from "./../../utils";

// 测试使用
// import { Checkbox, Notice, locale } from 'seedsui-react'
// 内库使用
import locale from "./../../../../locale";
import Checkbox from "./../../../../Checkbox";
import Notice from "./../../../../Notice";

// 附近结果
function Main(_ref) {
  var list = _ref.list,
    onChange = _ref.onChange;
  return /*#__PURE__*/React.createElement("div", {
    className: "mappage-nearby-main"
  }, Array.isArray(list) ? list.map(function (item, index) {
    return /*#__PURE__*/React.createElement("div", {
      className: "mappage-info-item",
      key: index,
      "data-nearby-item-id": "".concat(item.longitude, ",").concat(item.latitude),
      onClick: function onClick(e) {
        activeItemTarget(e.currentTarget);
        onChange && onChange(item);
      }
    }, /*#__PURE__*/React.createElement("div", {
      className: "mappage-info-item-content"
    }, /*#__PURE__*/React.createElement("p", {
      className: "mappage-info-item-content-title"
    }, item.title), /*#__PURE__*/React.createElement("p", {
      className: "mappage-info-item-content-description"
    }, item.address || '')), /*#__PURE__*/React.createElement(Checkbox, {
      checked: true
    }));
  }) : /*#__PURE__*/React.createElement(Notice, {
    caption: locale('暂无数据', 'SeedsUI_no_data')
  }));
}
export default Main;