var _excluded = ["map", "icon", "longitude", "latitude", "onDragStart", "onDragEnd"];
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React, { useEffect, useRef, forwardRef, useImperativeHandle } from 'react';

// 中心点标注
var CenterMarker = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var map = _ref.map,
    icon = _ref.icon,
    longitude = _ref.longitude,
    latitude = _ref.latitude,
    onDragStart = _ref.onDragStart,
    onDragEnd = _ref.onDragEnd,
    props = _objectWithoutProperties(_ref, _excluded);
  var rootRef = useRef(null);

  // 创建中心点独立的图层, 防止被清理
  var layerGroupRef = useRef(null);

  // 节点
  useImperativeHandle(ref, function () {
    return {
      rootDOM: rootRef.current,
      getRootDOM: function getRootDOM() {
        return rootRef.current;
      }
    };
  });

  // Drag icon style interaction
  useEffect(function () {
    // 创建图层组
    layerGroupRef.current = window.L.layerGroup().addTo(map.leafletMap);

    // 增加drag事件监听
    map.onDragStart = function (map) {
      var _rootRef$current, _rootRef$current$remo;
      rootRef === null || rootRef === void 0 || (_rootRef$current = rootRef.current) === null || _rootRef$current === void 0 || (_rootRef$current = _rootRef$current.classList) === null || _rootRef$current === void 0 || (_rootRef$current$remo = _rootRef$current.remove) === null || _rootRef$current$remo === void 0 || _rootRef$current$remo.call(_rootRef$current, 'active');
      onDragStart && onDragStart(map);
    };
    map.onDragEnd = function (map) {
      var _rootRef$current2, _rootRef$current2$add;
      rootRef === null || rootRef === void 0 || (_rootRef$current2 = rootRef.current) === null || _rootRef$current2 === void 0 || (_rootRef$current2 = _rootRef$current2.classList) === null || _rootRef$current2 === void 0 || (_rootRef$current2$add = _rootRef$current2.add) === null || _rootRef$current2$add === void 0 || _rootRef$current2$add.call(_rootRef$current2, 'active');
      onDragEnd && onDragEnd(map);
    };
    // eslint-disable-next-line
  }, []);
  useEffect(function () {
    if (!longitude || !latitude) {
      return;
    }
    if (layerGroupRef.current) {
      layerGroupRef.current.clearLayers();
    }
    map.addMarker({
      longitude: longitude,
      latitude: latitude,
      icon: icon
    }, {
      layerGroup: layerGroupRef.current
    });
    // eslint-disable-next-line
  }, [longitude, latitude]);
  return /*#__PURE__*/React.createElement("span", _extends({}, props, {
    className: "map-center-marker active".concat(props !== null && props !== void 0 && props.className ? ' ' + props.className : ''),
    ref: rootRef
  }));
});
export default CenterMarker;