// Create leaflet map
function createMap(container, _ref) {
  var _window;
  var center = _ref.center,
    _ref$minZoom = _ref.minZoom,
    minZoom = _ref$minZoom === void 0 ? 1 : _ref$minZoom,
    _ref$maxZoom = _ref.maxZoom,
    maxZoom = _ref$maxZoom === void 0 ? 20 : _ref$maxZoom,
    _ref$zoom = _ref.zoom,
    zoom = _ref$zoom === void 0 ? 13 : _ref$zoom;
  if (!window.L) {
    return '请在Map组件需要使用APILoader包裹';
  }

  // 百度地图最小3
  if (window.BMap && minZoom < 3) {
    // eslint-disable-next-line
    minZoom = 3;
  }
  var map = null;

  // Init leaflet map
  var config = {
    attributionControl: false,
    // 隐藏版权控件
    zoomControl: false,
    // 隐藏放大缩小控件
    maxZoom: maxZoom,
    minZoom: minZoom,
    zoom: zoom,
    center: [(center === null || center === void 0 ? void 0 : center.latitude) || 53.895658919017706, (center === null || center === void 0 ? void 0 : center.longitude) || -132.7236492753227]
  };
  // 百度tile layer插件
  if ((_window = window) !== null && _window !== void 0 && (_window = _window.L) !== null && _window !== void 0 && (_window = _window.CRS) !== null && _window !== void 0 && _window.Baidu) {
    config.crs = window.L.CRS.Baidu;
  }
  map = window.L.map(container, config);
  return map;
}
export default createMap;