import React, { forwardRef } from 'react';
import Navigation from "./Navigation";

// 测试使用
// import { locale, Checkbox } from 'seedsui-react'
// 内库使用
import Checkbox from "./../../../../Checkbox";
import locale from "./../../../../locale";

// 当前位置
function Current(_ref, ref) {
  var map = _ref.map,
    active = _ref.active,
    value = _ref.value,
    readOnly = _ref.readOnly,
    onChange = _ref.onChange;
  return /*#__PURE__*/React.createElement("div", {
    className: "map-nearbyControl-item",
    onClick: function onClick(e) {
      map.panTo({
        longitude: value.longitude,
        latitude: value.latitude
      });
      if (!readOnly) {
        onChange && onChange(value);
      }
    },
    ref: ref
  }, /*#__PURE__*/React.createElement("div", {
    className: "map-nearbyControl-item-content"
  }, /*#__PURE__*/React.createElement("div", {
    className: "map-nearbyControl-item-content-title"
  }, /*#__PURE__*/React.createElement("div", {
    className: "flex-1"
  }, (value === null || value === void 0 ? void 0 : value.name) || locale('当前位置', 'SeedsUI_current_location')), /*#__PURE__*/React.createElement(Navigation, {
    map: map,
    longitude: value === null || value === void 0 ? void 0 : value.longitude,
    latitude: value === null || value === void 0 ? void 0 : value.latitude,
    address: value === null || value === void 0 ? void 0 : value.address
  })), /*#__PURE__*/React.createElement("div", {
    className: "map-nearbyControl-item-content-description"
  }, /*#__PURE__*/React.createElement("div", {
    className: "flex-1"
  }, (value === null || value === void 0 ? void 0 : value.address) || ''), /*#__PURE__*/React.createElement("div", {
    className: "map-nearbyControl-item-checkbox"
  }, !readOnly && /*#__PURE__*/React.createElement(Checkbox, {
    checked: (active === null || active === void 0 ? void 0 : active.latitude) && (active === null || active === void 0 ? void 0 : active.latitude) === (value === null || value === void 0 ? void 0 : value.latitude) && (active === null || active === void 0 ? void 0 : active.longitude) === (value === null || value === void 0 ? void 0 : value.longitude)
  })))));
}
export default /*#__PURE__*/forwardRef(Current);