import React from 'react';

// 测试使用
// import { Checkbox, Notice, locale } from 'seedsui-react'
// 内库使用
import locale from "./../../../locale";
import Checkbox from "./../../../Checkbox";
import Notice from "./../../../Notice";

// 附近结果
function Main(_ref) {
  var active = _ref.active,
    list = _ref.list,
    onChange = _ref.onChange;
  return /*#__PURE__*/React.createElement("div", {
    className: "map-nearbyControl-main"
  }, Array.isArray(list) && list.length ? list.map(function (item, index) {
    return /*#__PURE__*/React.createElement("div", {
      className: "map-nearbyControl-item",
      key: index,
      "data-nearby-item-id": "".concat(item.longitude, ",").concat(item.latitude),
      onClick: function onClick(e) {
        onChange && onChange(item);
      }
    }, /*#__PURE__*/React.createElement("div", {
      className: "map-nearbyControl-item-content"
    }, /*#__PURE__*/React.createElement("p", {
      className: "map-nearbyControl-item-content-title"
    }, item.name), /*#__PURE__*/React.createElement("p", {
      className: "map-nearbyControl-item-content-description"
    }, item.address || '')), /*#__PURE__*/React.createElement(Checkbox, {
      checked: (active === null || active === void 0 ? void 0 : active.latitude) && (active === null || active === void 0 ? void 0 : active.latitude) === (item === null || item === void 0 ? void 0 : item.latitude) && (active === null || active === void 0 ? void 0 : active.longitude) === (item === null || item === void 0 ? void 0 : item.longitude)
    }));
  }) : /*#__PURE__*/React.createElement(Notice, {
    caption: locale('暂无数据', 'SeedsUI_no_data')
  }));
}
export default Main;