function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import React, { forwardRef, useImperativeHandle, useRef, useState } from 'react';
import Page from "./Page";

// 测试使用
// import { locale } from 'seedsui-react'
// 内库使用
import locale from "./../../../locale";

// 搜索
function SearchControl(_ref, ref) {
  var map = _ref.map,
    onChange = _ref.onChange;
  // 容器
  var rootRef = useRef(null);

  // 搜索结果页面显隐
  var _useState = useState(false),
    _useState2 = _slicedToArray(_useState, 2),
    visible = _useState2[0],
    setVisible = _useState2[1];

  // 节点
  useImperativeHandle(ref, function () {
    return {
      rootDOM: rootRef.current,
      getRootDOM: function getRootDOM() {
        return rootRef.current;
      }
    };
  });
  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("div", {
    ref: rootRef,
    className: "map-searchControl-navigation",
    onClick: function onClick() {
      setVisible(!visible);
    }
  }, /*#__PURE__*/React.createElement("div", {
    className: "map-searchControl-navigation-icon"
  }), /*#__PURE__*/React.createElement("div", {
    className: "map-searchControl-navigation-label"
  }, locale('搜索', 'SeedsUI_search'))), /*#__PURE__*/React.createElement(Page, {
    visible: visible,
    onVisibleChange: setVisible,
    map: map,
    onChange: onChange
  }));
}
export default /*#__PURE__*/forwardRef(SearchControl);