import locale from "./../../../locale";

// 地址逆解析函数
function osmGetAddress(_ref) {
  var longitude = _ref.longitude,
    latitude = _ref.latitude;
  var url = 'https://nominatim.openstreetmap.org/reverse?format=json&lat=' + latitude + '&lon=' + longitude;
  return new Promise(function (resolve) {
    fetch(url).then(function (response) {
      return response.json();
    }).then(function (data) {
      resolve({
        address: data.display_name
      });
    }).catch(function (error) {
      resolve(locale('获取地址失败, 请稍后重试', 'SeedsUI_get_address_failed'));
    });
  });
}
export default osmGetAddress;