// 加载google地图资源
function loadGoogle(key) {
  return new Promise(function (resolve) {
    if (window.google) {
      resolve(window.google);
      return;
    }

    // Delete old script
    var scriptTag = document.getElementById('google-map-js');
    if (scriptTag) {
      scriptTag.parentNode.removeChild(scriptTag);
    }

    // Load js
    Object.loadScript("https://maps.googleapis.com/maps/api/js?key=".concat(key, "&libraries=places"), {
      attrs: {
        id: 'google-map-js'
      }
    }, function (result) {
      if (!result) {
        resolve("google\u5730\u56FE\u52A0\u8F7D\u5931\u8D25");
      } else {
        resolve(window.google);
      }
    });
  });
}
export default loadGoogle;