function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
var _excluded = ["list", "optionAttribute", "step", "duration", "autoPlay", "direction", "loop", "onClick"],
  _excluded2 = ["onClick"];
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
// require (PrototypeArray.js), 使用了equals方法
import React, { forwardRef, useRef, useImperativeHandle, useEffect } from 'react';
import Instance from "./instance.js";
var Marquee = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var _ref$list = _ref.list,
    list = _ref$list === void 0 ? [] : _ref$list,
    _ref$optionAttribute = _ref.optionAttribute,
    optionAttribute = _ref$optionAttribute === void 0 ? {} : _ref$optionAttribute,
    _ref$step = _ref.step,
    step = _ref$step === void 0 ? 50 : _ref$step,
    _ref$duration = _ref.duration,
    duration = _ref$duration === void 0 ? 300 : _ref$duration,
    _ref$autoPlay = _ref.autoPlay,
    autoPlay = _ref$autoPlay === void 0 ? 2000 : _ref$autoPlay,
    _ref$direction = _ref.direction,
    direction = _ref$direction === void 0 ? 'top' : _ref$direction,
    _ref$loop = _ref.loop,
    loop = _ref$loop === void 0 ? true : _ref$loop,
    _onClick = _ref.onClick,
    others = _objectWithoutProperties(_ref, _excluded);
  var rootRef = useRef(null);
  var instance = useRef(null);
  useImperativeHandle(ref, function () {
    return {
      rootDOM: rootRef === null || rootRef === void 0 ? void 0 : rootRef.current,
      instance: instance.current,
      getRootDOM: function getRootDOM() {
        return rootRef.current;
      },
      getInstance: function getInstance() {
        return instance.current;
      }
    };
  });
  useEffect(function () {
    if (instance.current || list.length === 0) return;
    initInstance();
    // eslint-disable-next-line
  }, []);
  useEffect(function () {
    console.log('更新');
    update();
    // eslint-disable-next-line
  }, [list]);
  function update() {
    if (!instance.current) return;
    instance.current.updateParams({
      start: 0,
      end: step * (list.length - 1)
    });
    if (autoPlay) {
      instance.current.play();
    }
  }
  function initInstance() {
    instance.current = new Instance(rootRef.current, {
      start: 0,
      end: step * (list.length - 1),
      step: step,
      duration: duration,
      delay: autoPlay,
      direction: direction,
      loop: loop
    });
    if (autoPlay) {
      instance.current.play();
    }
  }
  // 过滤已经回调的属性
  function filterProps(props) {
    if (!props) return {};
    var onClick = props.onClick,
      otherProps = _objectWithoutProperties(props, _excluded2);
    return _objectSpread({}, otherProps);
  }

  // 剔除掉onClick事件, 因为在容器onClick已经回调了
  var otherOptionAttribute = filterProps(optionAttribute);
  return /*#__PURE__*/React.createElement("ul", _extends({}, others, {
    className: "marquee".concat(others.className ? ' ' + others.className : ''),
    ref: rootRef
  }), list && list.map(function (item, index) {
    return /*#__PURE__*/React.createElement("li", _extends({
      key: index
    }, otherOptionAttribute, {
      className: "marquee-li".concat(otherOptionAttribute.className ? ' ' + otherOptionAttribute.className : ''),
      style: Object.assign({
        height: step + 'px'
      }, otherOptionAttribute.style || {}),
      onClick: function onClick(e) {
        if (_onClick) _onClick(e, item.name, [item], index);
      }
    }), item.name);
  }));
});
export default Marquee;