var _excluded = ["selected", "onChange", "multiple", "list", "cancelAttribute"];
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it.return != null) it.return(); } finally { if (didErr) throw err; } } }; }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
// require PrototypeArray.js
import React, { useRef, useEffect, useState, forwardRef, useImperativeHandle } from 'react';
import Tree from "./../Tree";
import locale from "./../locale";
var slotClass = 'menutiled-slot';
var slotSubClass = 'menutiled-slot-sub';
var tagClass = 'menutiled-tag';
var tagFontClass = 'menutiled-tag-font';
var iconMoreClass = 'menutiled-icon-more';
var iconSelectClass = 'menutiled-icon-checked';
var activeClass = 'active';
var MenuTiled = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var selected = _ref.selected,
    onChange = _ref.onChange,
    _ref$multiple = _ref.multiple,
    multiple = _ref$multiple === void 0 ? false : _ref$multiple,
    list = _ref.list,
    _ref$cancelAttribute = _ref.cancelAttribute,
    cancelAttribute = _ref$cancelAttribute === void 0 ? {} : _ref$cancelAttribute,
    others = _objectWithoutProperties(_ref, _excluded);
  var rootRef = useRef(null);
  var treeRef = useRef(null);
  var _useState = useState(null),
    _useState2 = _slicedToArray(_useState, 2),
    viewGroups = _useState2[0],
    setViewGroups = _useState2[1]; // 分组显示数据
  var _useState3 = useState(list),
    _useState4 = _slicedToArray(_useState3, 2),
    data = _useState4[0],
    setData = _useState4[1]; // 将list转换成标准格式

  useImperativeHandle(ref, function () {
    return {
      rootDOM: rootRef === null || rootRef === void 0 ? void 0 : rootRef.current,
      getRootDOM: function getRootDOM() {
        return rootRef.current;
      }
    };
  });

  // 格式化列表数据
  function fmtList() {
    if (!list || !list.length) return [];
    var listStr = JSON.stringify(list);
    var newList = Object.clone(list);
    if (!multiple) {
      // 单选需要children
      if (listStr.indexOf('"children"') === -1) {
        return newList.deepTree();
      }
    } else if (multiple) {
      // 多选需要拉平数据, 并对根节点(id为空)做根处理
      if (listStr.indexOf('"children"') !== -1 || listStr.indexOf('"parentid"') === -1) {
        // 有children或者没有parentid, 需要拉平数据
        // 因为树只支持拉平数据, 并且必须层级分明, 所以要对id为空的根节点做根处理
        var flattenTree = newList.flattenTree();
        // 提取根节点共同的parentid, 为根节点(例如: 全部)的id
        var rootParentId = getRootParentId(flattenTree);
        // 对id为空的根节点(例如: 全部)做根处理
        updateTreeRoot(flattenTree, rootParentId);

        // 更新选中的根节点
        data = flattenTree;
        if (selected && selected.length) updateTreeSelectedRoot();
        return flattenTree;
      }
      if (listStr.indexOf('"parentid"') !== -1) {
        // 已经拉平的数据需要对id为空的数据做根处理
        // 提取根节点共同的parentid, 为根节点(例如: 全部)的id
        var _rootParentId = getRootParentId(list);
        // 对id为空的根节点(例如: 全部)做根处理
        updateTreeRoot(list, _rootParentId);

        // 更新选中的根节点
        if (selected && selected.length) updateTreeSelectedRoot();
        return list;
      }
    }
    return list;
  }
  useEffect(function () {
    data = fmtList(); // eslint-disable-line
    setData(data);
    if (!multiple) setViewGroups([data]);
  }, [list]);

  /*
   *  单选
   */
  // 点击选项
  function handleClick(e) {
    if (e.target.classList.contains(tagClass)) {
      // 点击项
      // 选中点击行
      // const row = Number(e.target.getAttribute('data-index') || 0);
      var id = e.target.getAttribute('data-id');
      var item = data.getDeepTreeNode(id);
      // 删除后面的层级
      var hierarchy = Number(e.target.getAttribute('data-hierarchy') || 0);
      var newViewGroups = Object.clone(viewGroups);
      newViewGroups.splice(hierarchy + 1);
      // 如果有子级, 添加子级
      if (item && item.children && item.children.length) {
        // 添加子级
        if (!newViewGroups[hierarchy + 1]) newViewGroups[hierarchy + 1] = [];
        newViewGroups[hierarchy + 1] = item.children;
      } else if (onChange) {
        // 叶子节点点击触发
        onChange(e, item === null || item === void 0 ? void 0 : item.name, [item], data);
      }
      setViewGroups(newViewGroups);
    }
  }

  // 判断是否选中
  function isSelected(id) {
    if (!Array.isArray(selected) || !selected || !selected.length) return false;
    var _iterator = _createForOfIteratorHelper(selected),
      _step;
    try {
      for (_iterator.s(); !(_step = _iterator.n()).done;) {
        var item = _step.value;
        if (item.id === id) return true;
      }
    } catch (err) {
      _iterator.e(err);
    } finally {
      _iterator.f();
    }
    return false;
  }

  /*
   *  多选
   */
  var _useState5 = useState(selected),
    _useState6 = _slicedToArray(_useState5, 2),
    multipleSelected = _useState6[0],
    setMultipleSelected = _useState6[1];
  useEffect(function () {
    var _treeRef$current;
    if (!multipleSelected || !multipleSelected.length) {
      return;
    }
    var instance = treeRef === null || treeRef === void 0 || (_treeRef$current = treeRef.current) === null || _treeRef$current === void 0 ? void 0 : _treeRef$current.getInstance();
    if (instance) {
      instance.removeAllSelected();
      var _iterator2 = _createForOfIteratorHelper(multipleSelected),
        _step2;
      try {
        for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
          var item = _step2.value;
          instance.addSelected(item);
        }
      } catch (err) {
        _iterator2.e(err);
      } finally {
        _iterator2.f();
      }
    }
    // eslint-disable-next-line
  }, [JSON.stringify(multipleSelected)]);

  // 多选, 提取根节点共同的parentid, 为根节点(例如: 全部)的id, 默认为'-404'
  function getRootParentId(flattenTree) {
    var rootParentId = '-404';
    var root = flattenTree.getFlattenTreeRoots();
    var _iterator3 = _createForOfIteratorHelper(root),
      _step3;
    try {
      for (_iterator3.s(); !(_step3 = _iterator3.n()).done;) {
        var rootItem = _step3.value;
        if (rootItem.id && rootItem.id !== '-404') {
          rootParentId = rootItem.parentid;
          break;
        }
      }
    } catch (err) {
      _iterator3.e(err);
    } finally {
      _iterator3.f();
    }
    return rootParentId;
  }
  // 多选, 对id为空的根节点(例如: 全部)做根处理, 补充id、parentid、isroot
  function updateTreeRoot(flattenTree, rootParentId) {
    var _iterator4 = _createForOfIteratorHelper(flattenTree),
      _step4;
    try {
      for (_iterator4.s(); !(_step4 = _iterator4.n()).done;) {
        var item = _step4.value;
        if (!item.id) {
          item.parentid = '-2';
          item.id = rootParentId;
          item.isroot = '1';
          if (rootParentId) delete item.isLeaf;
        }
      }
    } catch (err) {
      _iterator4.e(err);
    } finally {
      _iterator4.f();
    }
  }
  // 多选时, list数据被转换: id为空的根节点被补充id和parentid=-2还有isroot=1, 所以selected也需要处理, 才能让树选中
  function updateTreeSelectedRoot() {
    var _iterator5 = _createForOfIteratorHelper(selected),
      _step5;
    try {
      for (_iterator5.s(); !(_step5 = _iterator5.n()).done;) {
        var selectedItem = _step5.value;
        if (!selectedItem.id) {
          // 根节点处理
          var rootParentId = getRootParentId(data);
          selectedItem.parentid = '-2';
          selectedItem.id = rootParentId;
          selectedItem.isroot = '1';
        }
        if (selectedItem.id && !selectedItem.parentid) {
          // 非根节点补充parentid
          var _iterator6 = _createForOfIteratorHelper(data),
            _step6;
          try {
            for (_iterator6.s(); !(_step6 = _iterator6.n()).done;) {
              var item = _step6.value;
              if (selectedItem.id === item.id) {
                selectedItem.parentid = item.parentid;
              }
            }
          } catch (err) {
            _iterator6.e(err);
          } finally {
            _iterator6.f();
          }
        }
      }
    } catch (err) {
      _iterator5.e(err);
    } finally {
      _iterator5.f();
    }
    setMultipleSelected(selected);
  }
  // 多选, 点击选中节点
  function handleChangeTree(e, value, options) {
    setMultipleSelected(options);
  }
  // 多选, 点击确定
  function handleSubmit(e) {
    var val = [];
    if (multipleSelected && multipleSelected.length) {
      var _iterator7 = _createForOfIteratorHelper(multipleSelected),
        _step7;
      try {
        for (_iterator7.s(); !(_step7 = _iterator7.n()).done;) {
          var item = _step7.value;
          val.push(item.name);
        }
      } catch (err) {
        _iterator7.e(err);
      } finally {
        _iterator7.f();
      }
    }
    if (onChange) onChange(e, val.join(','), multipleSelected, data);
  }
  function handleCancel(e) {
    if (selected && selected.length) {
      updateTreeSelectedRoot();
    }
    if (cancelAttribute && cancelAttribute.onClick) cancelAttribute.onClick(e);
  }
  return /*#__PURE__*/React.createElement("div", _extends({}, others, {
    className: "menutiled".concat(others.className ? ' ' + others.className : '').concat(multiple ? ' multiple' : ''),
    onClick: handleClick,
    ref: rootRef
  }), /*#__PURE__*/React.createElement("div", {
    className: "menutiled-wrapper"
  }, !multiple && (viewGroups || []).map(function (group, groupIndex) {
    return /*#__PURE__*/React.createElement("div", {
      key: groupIndex,
      className: "".concat(groupIndex ? slotSubClass : slotClass)
    }, group.map(function (option, optionIndex) {
      return /*#__PURE__*/React.createElement("div", {
        key: optionIndex,
        "data-index": optionIndex,
        "data-hierarchy": groupIndex,
        "data-id": option.id,
        className: "menutiled-tag".concat(isSelected(option.id) ? ' ' + activeClass : '')
      }, /*#__PURE__*/React.createElement("p", {
        className: tagFontClass
      }, option.name), option.children && option.children.length > 0 ? /*#__PURE__*/React.createElement("i", {
        className: iconMoreClass
      }) : /*#__PURE__*/React.createElement("i", {
        className: iconSelectClass
      }));
    }));
  }), multiple && data && data.length > 0 && /*#__PURE__*/React.createElement(Tree, {
    ref: treeRef,
    list: data,
    arrowAutoShow: true,
    selected: multipleSelected,
    selectedAutoClear: true,
    multiple: true,
    checkbox: true,
    onChange: handleChangeTree
  })), /*#__PURE__*/React.createElement("div", {
    className: "menutiled-handler"
  }, /*#__PURE__*/React.createElement("span", {
    className: "menutiled-cancel",
    onClick: handleCancel
  }, locale('取消', 'SeedsUI_cancel')), /*#__PURE__*/React.createElement("span", {
    className: "menutiled-submit",
    onClick: handleSubmit
  }, locale('确定', 'SeedsUI_ok'))));
});
export default MenuTiled;