var _excluded = ["drag", "transition", "lSide", "lSideAttribute", "rSide", "rSideAttribute", "children"];
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React, { useEffect, useRef, forwardRef, useImperativeHandle } from 'react';
import Page from "./../Page";
import Instance from "./instance.js";
var PagePull = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var _ref$drag = _ref.drag,
    drag = _ref$drag === void 0 ? true : _ref$drag,
    _ref$transition = _ref.transition,
    transition = _ref$transition === void 0 ? 'push' : _ref$transition,
    lSide = _ref.lSide,
    _ref$lSideAttribute = _ref.lSideAttribute,
    lSideAttribute = _ref$lSideAttribute === void 0 ? {} : _ref$lSideAttribute,
    rSide = _ref.rSide,
    _ref$rSideAttribute = _ref.rSideAttribute,
    rSideAttribute = _ref$rSideAttribute === void 0 ? {} : _ref$rSideAttribute,
    children = _ref.children,
    others = _objectWithoutProperties(_ref, _excluded);
  var rootRef = useRef(null);
  var instance = useRef(null);
  useEffect(function () {
    if (instance.current) return;
    initInstance();
    // eslint-disable-next-line
  }, []);
  useImperativeHandle(ref, function () {
    return {
      rootDOM: rootRef.current,
      instance: instance.current,
      getRootDOM: function getRootDOM() {
        return rootRef.current;
      },
      getInstance: function getInstance() {
        return instance.current;
      }
    };
  });
  function initInstance() {
    if (!(rootRef !== null && rootRef !== void 0 && rootRef.current)) return;
    instance.current = new Instance(rootRef.current, {
      drag: true,
      transition: transition || 'push',
      onShowedLeft: lSideAttribute.onShowed,
      onShowedRight: rSideAttribute.onShowed
    });
  }

  // 过滤已经回调的属性
  function filterProps(props) {
    if (!props) return props;
    var propsed = {};
    for (var n in props) {
      if (n !== 'onShowed') {
        propsed[n] = props[n];
      }
    }
    return propsed;
  }

  // 剔除掉onShowed事件, 因为在instance时已经回调了
  lSideAttribute = filterProps(lSideAttribute);
  rSideAttribute = filterProps(rSideAttribute);
  return /*#__PURE__*/React.createElement("div", {
    className: "page-pull",
    ref: rootRef
  }, /*#__PURE__*/React.createElement(Page, others, children, /*#__PURE__*/React.createElement("div", {
    className: "mask"
  })), lSide && /*#__PURE__*/React.createElement("aside", _extends({}, lSideAttribute, {
    className: "page-side-left".concat(lSideAttribute.className ? ' ' + lSideAttribute.className : ''),
    "data-transition": transition
  }), lSide), rSide && /*#__PURE__*/React.createElement("aside", _extends({}, lSideAttribute, {
    className: "page-side-right".concat(lSideAttribute.className ? ' ' + lSideAttribute.className : ''),
    "data-transition": transition
  }), rSide));
});
export default PagePull;