var _excluded = ["type", "list", "current", "onHide", "onChange", "children"];
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it.return != null) it.return(); } finally { if (didErr) throw err; } } }; }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React, { forwardRef, useState } from 'react';
import Modal from "./../Modal";
import Swipe from "./Swipe";
import VideoFull from "./../VideoFull";
var Preview = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var type = _ref.type,
    list = _ref.list,
    current = _ref.current,
    onHide = _ref.onHide,
    onChange = _ref.onChange,
    children = _ref.children,
    others = _objectWithoutProperties(_ref, _excluded);
  var _useState = useState(new Array(list.length)),
    _useState2 = _slicedToArray(_useState, 2),
    pauseList = _useState2[0],
    setPauseList = _useState2[1];
  if (!list || !list.length || !list[0].src) return null;

  // 当前选中项
  var activeIndex = 0;
  if (typeof current === 'number') {
    activeIndex = current;
  } else if (typeof current === 'string') {
    var _iterator = _createForOfIteratorHelper(list.entries()),
      _step;
    try {
      for (_iterator.s(); !(_step = _iterator.n()).done;) {
        var _step$value = _slicedToArray(_step.value, 2),
          index = _step$value[0],
          source = _step$value[1];
        if (source.src === current) activeIndex = index;
      }
    } catch (err) {
      _iterator.e(err);
    } finally {
      _iterator.f();
    }
  }

  // 图片单击隐藏, 视频单击无反应
  function handleVisibleChange(visible) {
    if (!visible) {
      if (onHide) onHide();
    }
  }

  // 滑动视频需要暂停其它视频
  function handleChange(s) {
    // 暂停所有视频
    if (type === 'video') {
      var newPauseList = list.map(function () {
        return true;
      });
      setPauseList(newPauseList);
      setTimeout(function () {
        setPauseList(new Array(list.length));
      }, 500);
    }
    if (onChange) onChange(s, list[s.activeIndex], s.activeIndex);
  }
  return /*#__PURE__*/React.createElement(Modal, {
    visible: true,
    animation: "slideUp",
    className: "preview-modal",
    onVisibleChange: handleVisibleChange
  }, /*#__PURE__*/React.createElement(Swipe, _extends({
    ref: ref,
    containerChildren: children,
    defaultIndex: activeIndex,
    onChange: handleChange
  }, others), list.map(function (source, index) {
    return /*#__PURE__*/React.createElement("div", {
      className: "swiper-slide",
      key: index
    }, /*#__PURE__*/React.createElement("div", {
      className: "swiper-zoom-container"
    }, type !== 'video' && /*#__PURE__*/React.createElement("img", {
      alt: "",
      className: "swiper-zoom-target",
      src: source.src
    }), type === 'video' && /*#__PURE__*/React.createElement(VideoFull, {
      pause: pauseList[index],
      poster: source.thumb,
      src: source.src,
      autoPlay: false,
      bar: /*#__PURE__*/React.createElement("div", {
        className: "videofull-close",
        onClick: onHide
      })
    }), source.children));
  })));
});
export default Preview;