var _excluded = ["barContentRender", "percent", "max", "min", "value", "children", "barProps"];
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React, { forwardRef, useRef, useImperativeHandle } from 'react';
export default /*#__PURE__*/forwardRef(function (_ref, ref) {
  var barContentRender = _ref.barContentRender,
    percent = _ref.percent,
    _ref$max = _ref.max,
    max = _ref$max === void 0 ? 100 : _ref$max,
    _ref$min = _ref.min,
    min = _ref$min === void 0 ? 0 : _ref$min,
    _ref$value = _ref.value,
    value = _ref$value === void 0 ? 0 : _ref$value,
    children = _ref.children,
    barProps = _ref.barProps,
    others = _objectWithoutProperties(_ref, _excluded);
  var rootRef = useRef(null);

  // 节点
  useImperativeHandle(ref, function () {
    return {
      rootDOM: rootRef.current,
      getRootDOM: function getRootDOM() {
        return rootRef.current;
      }
    };
  });

  // 计算实际的百分比
  var barPercent = 0;
  if (!isNaN(percent)) {
    barPercent = percent;
  } else if (!isNaN(max) && !isNaN(value)) {
    barPercent = (value - min) / (max - min) * 100;
    console.log('barPercent:', barPercent);
  }
  if (barPercent > 100) {
    barPercent = 100;
  } else if (barPercent < 0) {
    barPercent = 0;
  }
  return /*#__PURE__*/React.createElement("div", _extends({}, others, {
    className: "progress".concat(others.className ? ' ' + others.className : ''),
    ref: rootRef
  }), /*#__PURE__*/React.createElement("span", _extends({}, barProps, {
    className: "progress-bar".concat(barProps !== null && barProps !== void 0 && barProps.className ? ' ' + barProps.className : ''),
    style: Object.assign({}, (barProps === null || barProps === void 0 ? void 0 : barProps.style) || {}, {
      width: barPercent + '%'
    })
  }), typeof barContentRender === 'function' && barContentRender({
    percent: barPercent
  })), children);
});