import React, { forwardRef } from 'react';
import getCancelVisible from "./getCancelVisible";
import getSubmitVisible from "./getSubmitVisible";
import Cancel from "./Cancel";
import Submit from "./Submit";
import Caption from "./Caption";
var Head = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var captionProps = _ref.captionProps,
    submitProps = _ref.submitProps,
    cancelProps = _ref.cancelProps,
    onSubmitClick = _ref.onSubmitClick,
    onCancelClick = _ref.onCancelClick;
  // 是否隐藏取消
  var cancelVisible = getCancelVisible(cancelProps, onCancelClick);
  // 是否隐藏确认, 隐藏确认按钮时, 取消按钮要在右侧显示
  var submitVisible = getSubmitVisible(submitProps, onSubmitClick);

  // 只显示标题
  if (!cancelVisible && !submitVisible) {
    return /*#__PURE__*/React.createElement("div", {
      className: "picker-header",
      ref: ref
    }, /*#__PURE__*/React.createElement(Caption, {
      captionProps: captionProps
    }));
  }

  // 带按钮
  return /*#__PURE__*/React.createElement("div", {
    className: "picker-header",
    ref: ref
  }, /*#__PURE__*/React.createElement("div", {
    className: "picker-header-button left"
  }, submitVisible && cancelVisible ? /*#__PURE__*/React.createElement(Cancel, {
    cancelProps: cancelProps,
    onCancelClick: onCancelClick
  }) : null), /*#__PURE__*/React.createElement(Caption, {
    captionProps: captionProps
  }), /*#__PURE__*/React.createElement("div", {
    className: "picker-header-button right"
  }, !submitVisible && cancelVisible ? /*#__PURE__*/React.createElement(Cancel, {
    cancelProps: cancelProps,
    onCancelClick: onCancelClick
  }) : null, submitVisible && /*#__PURE__*/React.createElement(Submit, {
    submitProps: submitProps,
    onSubmitClick: onSubmitClick
  })));
});
export default Head;