// 判断此项是否过滤
function filterItem(item, keyword) {
  var _item$children;
  // When have children display parent
  if (!keyword || item !== null && item !== void 0 && (_item$children = item.children) !== null && _item$children !== void 0 && _item$children.length) return true;

  // Match title
  if (typeof (item === null || item === void 0 ? void 0 : item.name) === 'string' && item.name) {
    if (item.name.indexOf(keyword) !== -1) {
      return true;
    }
  }

  // Match description
  if (typeof (item === null || item === void 0 ? void 0 : item.description) === 'string' && item.description) {
    if (item.description.indexOf(keyword) !== -1) {
      return true;
    }
  }
  return false;
}

// Format list data, filter valid data
function formatList(list, keyword, onSearch) {
  // List error
  if (!Array.isArray(list)) {
    console.error('Picker.Modal: Wrong parameter with "list"! You need pass a Array');
    return [];
  }

  // Custom filter
  if (typeof onSearch === 'function') {
    var _newList = onSearch({
      keyword: keyword,
      list: list
    });
    if (Array.isArray(_newList)) {
      return _newList;
    }
  }

  // Default filter
  var newList = Object.clone(list);
  return newList.filter(function (item) {
    // filter children in list item
    if (Array.isArray(item.children) && item.children.length) {
      item.children = item.children.filter(function (child) {
        return filterItem(child, keyword);
      });
    }
    // filter list
    return filterItem(item, keyword);
  });
}
export default formatList;