import React from 'react';
// 测试使用
// import { Bridge } from 'seedsui-react'
// 内库使用
import Bridge from "./../../Bridge";

// 预览
function Preview(_ref) {
  var value = _ref.value,
    onDelete = _ref.onDelete;
  // 图片加载完成
  function handleImgLoad(e) {
    var target = e.target;
    target.parentNode.setAttribute('data-complete', '1');
  }
  // 图片加载失败
  function handleImgError(e) {
    var target = e.target;
    target.parentNode.setAttribute('data-complete', '0');
  }

  // 未签显示签名
  return /*#__PURE__*/React.createElement("div", {
    className: "photos-item signature-photo",
    style: {
      backgroundImage: "url(".concat(value, ")")
    },
    onClick: function onClick() {
      Bridge.previewImage({
        urls: [value],
        current: value
      });
    }
  }, /*#__PURE__*/React.createElement("img", {
    className: "photos-item-img",
    src: value,
    alt: "",
    onLoad: handleImgLoad,
    onError: handleImgError
  }), /*#__PURE__*/React.createElement("div", {
    className: "photos-item-error"
  }), /*#__PURE__*/React.createElement("div", {
    className: "photos-item-load"
  }), onDelete && /*#__PURE__*/React.createElement("div", {
    className: "photos-delete",
    onClick: function onClick(e) {
      onDelete === null || onDelete === void 0 || onDelete('');
      e.stopPropagation();
    }
  }, /*#__PURE__*/React.createElement("div", {
    className: "photos-delete-icon"
  })));
}
export default Preview;