import drawBgColor from "./drawBgColor";
var rotateBase64 = function rotateBase64(data, _ref) {
  var backgroundColor = _ref.backgroundColor;
  //传入需要旋转的base64图片
  // 生成图片，将图片旋转指定角度后绘制到canvas上
  return new Promise(function (resolve, reject) {
    var img = document.createElement('img');
    var canvas = document.createElement('canvas');
    var ctx = canvas.getContext('2d');
    var cutCoor = {
      sx: 0,
      sy: 0,
      ex: 0,
      ey: 0
    }; // 裁剪坐标
    img.onload = function () {
      var imgWidth = img.width;
      var imgHeight = img.height;
      var size = imgHeight;
      canvas.width = size * 2;
      canvas.height = size * 2;
      cutCoor.sx = size;
      cutCoor.sy = size - imgWidth;
      cutCoor.ex = size + imgHeight;
      cutCoor.ey = size + imgWidth;
      ctx.translate(size, size);
      ctx.rotate(-Math.PI / 2); // 旋转-90度

      // 绘制背景
      if (backgroundColor && typeof backgroundColor === 'string' && backgroundColor !== 'transparent') {
        drawBgColor(backgroundColor, {
          ctx: ctx
        });
      }

      // 绘制图片
      ctx.drawImage(img, 0, 0);
      var imgData = ctx.getImageData(cutCoor.sx, cutCoor.sy, cutCoor.ex, cutCoor.ey);
      canvas.width = imgHeight;
      canvas.height = imgWidth;
      ctx.putImageData(imgData, 0, 0);
      resolve(canvas.toDataURL('image/png'));
    };
    img.setAttribute('src', data);
  });
};
export default rotateBase64;