function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
import React, { useImperativeHandle, forwardRef, useRef } from 'react';
import { createPortal } from 'react-dom';
import Main from "./../Main";

// 测试使用
// import { Layout } from 'seedsui-react'
// 内库使用
import Layout from "./../../Layout";

// Modal
var Modal = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var portal = _ref.portal,
    visible = _ref.visible,
    value = _ref.value,
    onBeforeChange = _ref.onBeforeChange,
    onChange = _ref.onChange,
    onVisibleChange = _ref.onVisibleChange,
    color = _ref.color,
    backgroundColor = _ref.backgroundColor,
    _ref$pageProps = _ref.pageProps,
    pageProps = _ref$pageProps === void 0 ? {} : _ref$pageProps;
  // 节点
  var rootRef = useRef(null);
  useImperativeHandle(ref, function () {
    var _rootRef$current, _rootRef$current2, _rootRef$current3;
    return {
      rootDOM: (rootRef === null || rootRef === void 0 || (_rootRef$current = rootRef.current) === null || _rootRef$current === void 0 ? void 0 : _rootRef$current.rootDOM) || (rootRef === null || rootRef === void 0 ? void 0 : rootRef.current),
      getRootDOM: rootRef !== null && rootRef !== void 0 && (_rootRef$current2 = rootRef.current) !== null && _rootRef$current2 !== void 0 && _rootRef$current2.getRootDOM ? rootRef === null || rootRef === void 0 || (_rootRef$current3 = rootRef.current) === null || _rootRef$current3 === void 0 ? void 0 : _rootRef$current3.getRootDOM : function () {
        return rootRef.current;
      }
    };
  });
  var Node = /*#__PURE__*/React.createElement(Layout, _extends({
    ref: rootRef,
    safeArea: true
    // 显示在其它page前面渲染
    ,
    style: {
      zIndex: document.querySelectorAll('layout').length + 5
    }
  }, pageProps, {
    className: "full bg-white".concat(pageProps !== null && pageProps !== void 0 && pageProps.className ? ' ' + pageProps.className : '').concat(visible === true ? '' : ' hide')
  }), visible && /*#__PURE__*/React.createElement(Main, {
    value: value,
    onBeforeChange: onBeforeChange,
    onChange: onChange,
    onCancel: function onCancel() {
      onVisibleChange && onVisibleChange(false);
    }
    // 绘画配置
    ,
    color: color,
    backgroundColor: backgroundColor
  }));
  if (portal) {
    return /*#__PURE__*/createPortal(Node, portal);
  }
  return Node;
});
export default Modal;