var _excluded = ["portal", "position", "duration", "maskClickable", "visible", "onVisibleChange", "licon", "ricon", "maskProps", "children"];
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React, { forwardRef, useEffect, useRef, useImperativeHandle } from 'react';
import { createPortal } from 'react-dom';
var Toast = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var portal = _ref.portal,
    _ref$position = _ref.position,
    position = _ref$position === void 0 ? 'middle' : _ref$position,
    _ref$duration = _ref.duration,
    duration = _ref$duration === void 0 ? 2000 : _ref$duration,
    _ref$maskClickable = _ref.maskClickable,
    maskClickable = _ref$maskClickable === void 0 ? true : _ref$maskClickable,
    _ref$visible = _ref.visible,
    visible = _ref$visible === void 0 ? false : _ref$visible,
    onVisibleChange = _ref.onVisibleChange,
    licon = _ref.licon,
    ricon = _ref.ricon,
    _ref$maskProps = _ref.maskProps,
    maskProps = _ref$maskProps === void 0 ? {} : _ref$maskProps,
    children = _ref.children,
    props = _objectWithoutProperties(_ref, _excluded);
  var rootRef = useRef(null);
  var containerRef = useRef(null);
  useImperativeHandle(ref, function () {
    return {
      rootDOM: rootRef.current,
      containerDOM: containerRef.current,
      getRootDOM: function getRootDOM() {
        return rootRef.current;
      },
      getContainerDOM: function getContainerDOM() {
        return containerRef.current;
      }
    };
  });
  useEffect(function () {
    if (visible) {
      handleDuration();
    }
    // eslint-disable-next-line
  }, [visible]);

  // 显示数秒后，自动消失
  function handleDuration() {
    if (typeof duration !== 'number' || !duration || !onVisibleChange) {
      return;
    }
    if (rootRef.current.durationTimeout) window.clearTimeout(rootRef.current.durationTimeout);
    rootRef.current.durationTimeout = setTimeout(function () {
      onVisibleChange(false);
    }, duration);
  }

  // 获取激活状态样式
  function getActiveClass() {
    return visible ? ' active' : '';
  }
  return /*#__PURE__*/createPortal( /*#__PURE__*/React.createElement("div", _extends({}, maskProps, {
    className: "mask toast-mask".concat(maskProps.className ? ' ' + maskProps.className : '').concat(maskClickable ? ' toast-propagation' : '').concat(getActiveClass()),
    ref: rootRef
  }), /*#__PURE__*/React.createElement("div", _extends({
    ref: containerRef
  }, props, {
    className: "toast ".concat(position || 'middle').concat(props.className ? ' ' + props.className : '').concat(getActiveClass())
  }), /*#__PURE__*/React.createElement("div", {
    className: "toast-wrapper"
  }, licon && licon, /*#__PURE__*/React.createElement("div", {
    className: "toast-content"
  }, children), ricon && ricon))), portal || document.getElementById('root') || document.body);
});
export default /*#__PURE__*/React.memo(Toast, function (prevProps, nextProps) {
  if (nextProps.visible === prevProps.visible) return true;
  return false;
});