import React, { useEffect } from 'react';
import Item from "./Item";
import { active, expandKeyword } from "./../utils/index";

// 树菜单项
var List = function List(_ref) {
  var itemRender = _ref.itemRender,
    keyword = _ref.keyword,
    rootRef = _ref.rootRef,
    value = _ref.value,
    list = _ref.list,
    onExpand = _ref.onExpand,
    onCollapse = _ref.onCollapse,
    onChange = _ref.onChange;
  // 值变化时, 修改展开和选中
  useEffect(function () {
    active({
      rootRef: rootRef,
      value: value,
      list: list
    });
    // eslint-disable-next-line
  }, [value]);
  useEffect(function () {
    expandKeyword({
      rootRef: rootRef,
      keyword: keyword,
      list: list
    });
    // eslint-disable-next-line
  }, [keyword]);
  function handleChange(item) {
    if (onChange) onChange([item]);
  }
  if (!Array.isArray(list) || !list.length) return null;
  return /*#__PURE__*/React.createElement(React.Fragment, null, list.map(function (item, index) {
    return /*#__PURE__*/React.createElement(Item, {
      key: item.id || index,
      itemRender: itemRender,
      keyword: keyword,
      item: item,
      onExpand: onExpand,
      onCollapse: onCollapse,
      onChange: handleChange
    });
  }));
};
export default List;