import clearClass from "./clearClass";
import getDOM from "./getDOM";
import getPredecessorDOM from "./getPredecessorDOM";

// 选中先辈并展开
function active(_ref) {
  var rootRef = _ref.rootRef,
    value = _ref.value,
    list = _ref.list;
  if (!(rootRef !== null && rootRef !== void 0 && rootRef.current) || !list || !list.length) return;
  clearClass({
    rootRef: rootRef,
    classNames: ['active', 'expand']
  });

  // 获取所有需要选中项, 当前项若展开则收缩
  var current = null; // 当前项
  var currentExpand = true; // 当前项是否展开
  var needActives = null;
  if (Array.isArray(value) && value[0] && (typeof value[0].id === 'string' || typeof value[0].id === 'number')) {
    current = getDOM({
      rootRef: rootRef,
      id: value[0].id
    });
    // 记录点击dom的展开状态
    if (current) {
      currentExpand = current.classList.contains('expand');
    }
    needActives = getPredecessorDOM({
      rootRef: rootRef,
      ids: [value[0].id],
      list: list
    });
  }

  // 选中dom
  if (needActives && needActives.length) {
    for (var i = 0, needActive; needActive = needActives[i++];) {
      needActive.classList.add('active');
      needActive.classList.add('expand');
    }
  }

  // 点击dom收展
  if (current) {
    if (currentExpand) {
      current.classList.remove('expand');
    } else {
      current.classList.add('expand');
    }
  }
}
export default active;